Subject: bug#64789: 30.0.50; EPA fails to encrypt files; decryption and manual encryption works

From: Eli Zaretskii <[email-masked]>
Date: Sat, 22 Jul 2023 14:44:52 +0300

> Date: Sat, 22 Jul 2023 12:41:54 +0300
> From:  Daniel Semyonov via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <[email-masked]>
> 
> 
> For the past few days I've noticed I can no longer encrypt files with
> EPA, both new files which I save with a '.gpg' extension and choose a
> recipient, or existing files which are successfully decrypted but I can't
> modify and save.
> Specifically, when attempting to save, EPA just gets stuck indefinitely
> with "Saving file <some file>.gpg..." in the echo area.
> 
> AFAIK my GPG config hasn't changed in months (and I fairly recently
> encrypted a file with EPA), and I can manually invoke it to encrypt
> files (through the terminal or dired for example).
> I also got an error yesterday when trying to encrypt a file through
> dired (by pressing '!' on the file and typing the command) which said
> something about GPG not finding a valid TTY, but I don't remember what
> it was and I can't reproduce it now.
> 
> To reproduce failure to save an existing file:
> 1. $ emacs -Q
> 2. C-x C-f <some file>.gpg
> 3. Toggle buffer modified by clicking the indicator on the mode line.
> 4. C-x C-s
> 5. Wait forever.
> 
> To reproduce failure to save a new file:
> 1. $ emacs -Q
> 2. C-x C-f <new file>.gpg
> 3. Toggle buffer modified by clicking the indicator on the mode line.
> 4. C-x C-s
> 5. Mark a recipient and press [OK].
> 6. Wait forever.

This is due to a change in the latest version of GnuPG.  We have this
in etc/PROBLEMS:

  *** Saving, via EasyPG, a file encrypted with GnuPG hangs

  This is known to happen with GnuPG v2.4.1.  The only known workaround
  is to downgrade to a version of GnuPG older than 2.4.1 (or, in the
  future, upgrade to a newer version which solves the problem, when such
  a fixed version becomes available).